#include <stdio.h>
#include <stdlib.h>
#include <omp.h>
#include <math.h>
#include "timing.h"

int main(int argc, char *argv[])
{
#define OUTPUT 0

int N = atoi(argv[1]);
int nthreads = atoi(argv[2]);
unsigned long ticksB4, ticksAFT, ticks;
double freq = 2.5e9;
int i;

double *factorials;
factorials = (double *) malloc((N+1) * sizeof(double) );

double final_sums[nthreads];


get_ticks(ticksB4);


factorials[0] = 0.;

#pragma omp parallel num_threads(nthreads) private(i)
{
int id = omp_get_thread_num();
int chunksize = N / nthreads;

int start = id*chunksize + 1;
int end = (id+1)*chunksize + 1;
if( id == nthreads-1 ) end = N+1;

factorials[start] = log((double) start );

for(i=start+1; i<end; i++) {
	factorials[i] = factorials[i] + log((double)i);
}
final_sums[id] = factorials[end-1];

#pragma omp barrier

#pragma omp single
{
	for(i=1;i<nthreads;i++){
		final_sums[i] = final_sums[i] + final_sums[i-1];
	}
}

if(id > 0){
	for(i=start; i<end; i++){
		factorials[i] = factorials[i] + final_sums[id-1];
	}
}


}




get_ticks(ticksAFT);
ticks = ticksAFT - ticksB4;

#if OUTPUT
/*
printf("\na:");
for(i=0; i<N; i++) {
	printf(" %d", a[i]);
}
printf("\n\n");
*/
printf("\nresult:");
for(i=0; i<N; i++) {
	printf(" %.3g", factorials[i]);
}
printf("\n\n");
#endif

printf("runtime (s): %g\n\n", ticks/freq);

return 0;
}
