#include <stdio.h>
#include <stdlib.h>
#include <omp.h>
#include "timing.h"

int main( int argc, char *argv[] )
{
	int N = atoi(argv[1]);
	int nthreads = atoi(argv[2]);
	unsigned long ticksB4, ticksAFT, ticks;
	double freq = 2.5e9;

	double *a;
	a = (double *) malloc(N * sizeof(double) );

	double local_sum[nthreads];
	double sum = 0.;

    int i;
	for (i = 0; i < N; i++) {
		a[i] = (double) i;
	}
    for (i = 0; i < nthreads; i++) {
        local_sum[i] = 0.;
    }

	get_ticks(ticksB4);

    #pragma omp parallel num_threads(nthreads) private(i) reduction(+:sum)
	{
		int id = omp_get_thread_num();
		int nthr = omp_get_num_threads();

    	for ( i = id; i < N; i+=nthr ) {
			sum += a[i];
    	}
	}

	printf("sum = %.3g\n", sum);


	get_ticks(ticksAFT);
	ticks = ticksAFT - ticksB4;
	printf("runtime (s): %g\n\n", ticks/freq);
}
